﻿Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win.UltraWinTree
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid

Public Class Form1
    Private WithEvents _ImportsBs As New BindingSource
    Public WithEvents ErrorSummaryButton As New EditorButton

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        ErrorSummaryButton.Text = "..."
        UltraTextEditor1.ButtonsRight.Add(ErrorSummaryButton)

        AddTestData()
    End Sub

    'Private Sub ImportList_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs)
    '    e.Layout.Override.TipStyleCell = TipStyle.Hide
    'End Sub

    Private Sub ImportList_InitializeRow(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeRowEventArgs)

        If e.Row.Cells("Status").Value IsNot DBNull.Value AndAlso e.Row.Cells("Status").Value <> "Complete" Then
            e.Row.Cells("Status").Column.MinValue = 0
            e.Row.Cells("Status").Column.MaxValue = e.Row.Cells("TotalFolders").Value
            e.Row.Cells("Status").EditorControl = _ProgressEditor
            e.Row.Cells("Status").Appearance.ThemedElementAlpha = Infragistics.Win.Alpha.Transparent
        End If

        'If e.Row.Cells("ErrorSummary").Value IsNot DBNull.Value AndAlso e.Row.Cells("ErrorSummary").Value.ToString.Length > 0 Then
        '    'e.Row.Cells("ErrorSummary").ToolTipText = e.Row.Cells("ErrorSummary").Text.Replace(",", vbCrLf)
        'End If

        e.Row.Cells("ErrorSummary").EditorControl = UltraTextEditor1


        e.Row.Cells("ImportDate").Column.Format = "M/dd/yyyy hh:mm tt"

    End Sub

    Private Sub AddTestData()

        Dim Sql As New System.Text.StringBuilder
        Sql.Append(" SELECT	batch_id As Id")
        Sql.Append("    	, date_started As ImportDate")
        Sql.Append("		, xml_filename As Filename")
        Sql.Append("	    , success_count As Success")
        Sql.Append("    	, failed_count As Errors")
        Sql.Append("    	, success_count + failed_count AS Processed")
        Sql.Append("	  	, total_count AS TotalFolders")
        Sql.Append("        , errors AS ErrorSummary")
        Sql.Append("    	, IIF(running = 1, CAST((success_count + failed_count) AS VARCHAR(10)),'Complete') AS Status ")
        Sql.Append("        , running as Running")
        Sql.Append(" FROM 	ans_xml_imports")
        Sql.Append(" WHERE	configuration_name = @ConfigurationName")
        Sql.Append(" ORDER BY Id DESC")

        Dim ds As New DataSet
        Dim dt As New DataTable
        dt.TableName = "Imports"
        dt.Columns.Add("Id", GetType(Integer))
        dt.Columns.Add("ImportDate", GetType(DateTime))
        dt.Columns.Add("Filename", GetType(String))
        dt.Columns.Add("Success", GetType(Integer))
        dt.Columns.Add("Errors", GetType(Integer))
        dt.Columns.Add("Processed", GetType(Integer))
        dt.Columns.Add("TotalFolders", GetType(Integer))
        dt.Columns.Add("ErrorSummary", GetType(String))
        dt.Columns.Add("Status", GetType(String))
        dt.Columns.Add("Running", GetType(Integer))
        ds.Tables.Add(dt)

        _ImportsBs.DataSource = ds
        _ImportsBs.DataMember = "Imports"

        '1st record
        Dim dr As DataRow
        dr = ds.Tables(0).NewRow
        dr("Id") = "454"
        dr("ImportDate") = Now.ToString
        dr("Filename") = "\january\week1.xml"
        dr("Success") = "5678"
        dr("Errors") = "23"
        dr("Processed") = "5701"
        dr("TotalFolders") = "6000"
        dr("ErrorSummary") = "truncation error, File not found"
        dr("Status") = ""
        dr("Running") = "0"
        ds.Tables(0).Rows.Add(dr)

        '2nd record
        dr = ds.Tables(0).NewRow
        dr("Id") = "469"
        dr("ImportDate") = Now.ToString
        dr("Filename") = "\october\week3.xml"
        dr("Success") = "334"
        dr("Errors") = "5"
        dr("Processed") = "339"
        dr("TotalFolders") = "500"
        dr("ErrorSummary") = "File not found, missing node"
        dr("Status") = ""
        dr("Running") = "0"
        ds.Tables(0).Rows.Add(dr)

        _ImportsBs.DataSource = ds
        _ImportsBs.DataMember = "Imports"

        Dim SelectedImportId As Integer = 0
        If ImportList.Rows.Count > 0 AndAlso ImportList.ActiveRow IsNot Nothing Then
            SelectedImportId = ImportList.ActiveRow.Cells("Id").Value
        Else
            SelectedImportId = 0
        End If

        If ImportList.DataSource Is Nothing Then
            ImportList.DataSource = _ImportsBs
        End If

        If _ImportsBs.List.Count > 0 And SelectedImportId > 0 Then
            Dim FoundIndex As Integer = 0
            FoundIndex = _ImportsBs.Find("Id", SelectedImportId)
            If FoundIndex <= 0 Then
                FoundIndex = 0
            End If
            ImportList.Rows(FoundIndex).Activate()
        End If

        ImportList.DisplayLayout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns

        'Dim ErrorList As New Infragistics.Win.ValueList
        'Dim Errors() As String = "error1, error2, error3, error4".Split(",")
        'For Each errorstring As String In Errors
        '    ErrorList.ValueListItems.Add(errorstring)
        'Next
        'ImportList.Rows(0).Cells("ErrorSummary").Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList
        'ImportList.Rows(0).Cells("ErrorSummary").ValueList = ErrorList
        'ImportList.Rows(0).Cells("ErrorSummary").DroppedDown = True
        'ImportList.Rows(1).Cells("ErrorSummary").Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList
        'ImportList.Rows(1).Cells("ErrorSummary").ValueList = ErrorList
        'ImportList.Rows(1).Cells("ErrorSummary").DroppedDown = True

    End Sub

    'Private Sub ImportList_MouseMove(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles ImportList.MouseMove

    '    Dim U As Infragistics.Win.UIElement = ImportList.DisplayLayout.UIElement.ElementFromPoint(New Point(e.X, e.Y))
    '    Dim C As Infragistics.Win.UltraWinGrid.UltraGridCell = U.GetContext(GetType(Infragistics.Win.UltraWinGrid.UltraGridCell))
    '    If C IsNot Nothing Then
    '        If C.Column.Key = "ErrorSummary" Then
    '            Dim tipInfo As New Infragistics.Win.UltraWinToolTip.UltraToolTipInfo(C.Value.ToString.Replace(",", vbCrLf), Infragistics.Win.ToolTipImage.None, "", Infragistics.Win.DefaultableBoolean.False)
    '            UltraToolTipManager1.SetUltraToolTip(ImportList, tipInfo)
    '        End If
    '    End If

    'End Sub

    'Private Sub ultraGrid1_MouseEnterElement(sender As Object, e As Infragistics.Win.UIElementEventArgs)

    '    Dim C As Infragistics.Win.UltraWinGrid.UltraGridCell = e.Element.GetContext(GetType(Infragistics.Win.UltraWinGrid.UltraGridCell))
    '    If C IsNot Nothing AndAlso C.Column.Key = "ErrorSummary" AndAlso C.Row.IsActiveRow Then
    '        Dim info As New Infragistics.Win.UltraWinToolTip.UltraToolTipInfo
    '        info.ToolTipTextFormatted = C.Value.ToString().Replace(",", "<br/>").Replace("~View report for more detail~", "<b>~View report for more detail~</b>")
    '        info.ToolTipTextStyle = Infragistics.Win.ToolTipTextStyle.Formatted
    '        UltraToolTipManager1.SetUltraToolTip(ImportList, info)
    '        UltraToolTipManager1.ShowToolTip(ImportList, C.GetUIElement.Rect)
    '    Else
    '        UltraToolTipManager1.HideToolTip()
    '    End If

    'End Sub


    'Private Sub ImportList_MouseLeaveElement(sender As Object, e As Infragistics.Win.UIElementEventArgs)
    '    UltraToolTipManager1.HideToolTip()
    'End Sub

    Private Sub UltraTextEditor1_EditorButtonClick(sender As Object, e As Infragistics.Win.UltraWinEditors.EditorButtonEventArgs) Handles UltraTextEditor1.EditorButtonClick

    End Sub
End Class
